<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AbstractCampaignSettingValidationError StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:AbstractCampaignSettingValidationError
 * @subpackage Structs
 */
class AbstractCampaignSettingValidationError extends AbstractStructBase
{
    /**
     * The SettingName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SettingName;
    /**
     * The ValidationMessage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ValidationMessage;
    /**
     * Constructor method for AbstractCampaignSettingValidationError
     * @uses AbstractCampaignSettingValidationError::setSettingName()
     * @uses AbstractCampaignSettingValidationError::setValidationMessage()
     * @param string $settingName
     * @param string $validationMessage
     */
    public function __construct($settingName = null, $validationMessage = null)
    {
        $this
            ->setSettingName($settingName)
            ->setValidationMessage($validationMessage);
    }
    /**
     * Get SettingName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSettingName()
    {
        return isset($this->SettingName) ? $this->SettingName : null;
    }
    /**
     * Set SettingName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $settingName
     * @return \StructType\AbstractCampaignSettingValidationError
     */
    public function setSettingName($settingName = null)
    {
        // validation for constraint: string
        if (!is_null($settingName) && !is_string($settingName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($settingName)), __LINE__);
        }
        if (is_null($settingName) || (is_array($settingName) && empty($settingName))) {
            unset($this->SettingName);
        } else {
            $this->SettingName = $settingName;
        }
        return $this;
    }
    /**
     * Get ValidationMessage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getValidationMessage()
    {
        return isset($this->ValidationMessage) ? $this->ValidationMessage : null;
    }
    /**
     * Set ValidationMessage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $validationMessage
     * @return \StructType\AbstractCampaignSettingValidationError
     */
    public function setValidationMessage($validationMessage = null)
    {
        // validation for constraint: string
        if (!is_null($validationMessage) && !is_string($validationMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($validationMessage)), __LINE__);
        }
        if (is_null($validationMessage) || (is_array($validationMessage) && empty($validationMessage))) {
            unset($this->ValidationMessage);
        } else {
            $this->ValidationMessage = $validationMessage;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AbstractCampaignSettingValidationError
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
